Attribute VB_Name = "Module123"
Private Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long
Public AAA

Public Function GetFileName(FilePath As String) As String
Dim A As Long

A = InStrRev(Replace$(FilePath, "/", "\"), "\")
If Not A = 0 And Not A = Len(FilePath) Then GetFileName = Mid$(FilePath, A + 1) Else GetFileName = FilePath
End Function

Public Function GetPathOnly(FilePath As String) As String
Dim A As Long

A = InStrRev(FilePath, "\")
If A > 1 Then GetPathOnly = Mid$(FilePath, 1, A)
End Function

Public Function GetPathMin(FilePath As String) As String
Dim CN, A, B, C
CN = 1
Ret:
  A = InStr(CN, FilePath, "\")
  If A = 0 Then
    GetPathMin = Mid(FilePath, 1, B - 1): Exit Function
  Else
    CN = A - -1
    B = InStr(CN, FilePath, "\")
    If B = 0 Then
      GetPathMin = Mid(FilePath, 1, C - 1): Exit Function
    Else
      CN = B - -1
      C = InStr(CN, FilePath, "\")
      If C = 0 Then
        GetPathMin = Mid(FilePath, 1, A - 1): Exit Function
      Else
        CN = C - -1: GoTo Ret
      End If
    End If
  End If
End Function

Public Function DirFilter(DirName As String) As String
On Error Resume Next
Dim L As Long
L = Len(DirName)
If Not L = 0 Then
  If Mid$(DirName, L, 1) = "\" Then
    L = L - 1
    DirFilter = Mid$(DirName, 1, L)
  Else
    DirFilter = DirName
  End If
Else
  DirFilter = ""
End If
End Function

Public Function FileNameOnly(FilePath As String) As String
Dim A As Long, B As Long, C As Long, E As String
FileW = GetFileName(DirFilter(FilePath))
  Do
    A = InStr(B + 1, FileW, ".")
    If A = 0 Then C = B: GoTo NEX
    B = InStr(A - -1, FileW, ".")
    If B = 0 Then C = A: GoTo NEX
  Loop
NEX:
  If Len(FilePath) < 2 Then FileNameOnly = FilePath: Exit Function
  If C = 0 Then FileNameOnly = FileW: Exit Function
  E = Mid$(FileW, 1, C - 1)
  FileNameOnly = E
End Function

Public Function GetExt(FileW As String) As String
Dim A As Long, S As String

S = GetFileName(FileW)
A = InStrRev(S, ".")
If Not A = 0 And Not A = Len(FileW) Then GetExt = LCase$(Mid$(S, A + 1))
End Function

Public Sub MMDir(Path As String)
On Error Resume Next
Dim i As Integer, A As String, N As Integer, n2 As Integer
i = 1
Do
  N = i + 1
  i = InStr(N, Path, "\")
  If i = 0 Then Exit Do
  n2 = i - 1
  A = Mid$(Path, 1, n2)
  If Not CheckFile(A) = 2 And Len(A) > 2 Then MkDir A
Loop
If Not CheckFile(Path) = 2 And Len(A) > 2 Then MkDir Path
End Sub

Private Function CheckFile(Name As String) As Integer
Dim S As Long
S = GetFileAttributes(Name)
If S = -1 Then CheckFile = 0: Exit Function
If S = 16 Then CheckFile = 2: Exit Function
CheckFile = 1
End Function

Public Function NoExt(FN As String) As String
Dim A As Long, B As Long

A = InStrRev(FN, ".", Len(FN))
If A = 0 Then NoExt = FN: Exit Function

Do
  A = InStr(B + 1, FN, ".")
  If A = 0 Then Exit Do
  B = A
Loop

NoExt = Mid$(FN, 1, B - 1)
End Function
