VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FastProgB"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'WinPB &H80000002&

Public Max As Long, Min As Long, Value As Long, BeOSStyle As Boolean, Border As Boolean
Public ReGetStyle As Boolean
Public WinNewStyle As Boolean
Public Win3DStyle As Boolean
Public BeOS3DStyle As Boolean
Dim WithEvents PB As PictureBox
Attribute PB.VB_VarHelpID = -1

Public Sub Init(PBObj As PictureBox, Optional MinValue As Long, Optional MaxValue As Long = 100, Optional InitValue As Long, Optional PBBeOSStyle As Boolean = True, Optional PBBorder As Boolean = True)
Set PB = PBObj
PB.AutoRedraw = False
PB.ScaleMode = 3
BeOSStyle = PBBeOSStyle
Max = MaxValue
Min = MinValue
Value = InitValue
Border = PBBorder
End Sub

Public Sub RePaint()
If BeOSStyle = True Then
  DrawPBBeOS
ElseIf ReGetStyle = True Then
  DrawPBReGet
ElseIf WinNewStyle = True Then
  DrawPBWinNew
ElseIf Win3DStyle = True Then
  DrawPBWin3D
ElseIf BeOS3DStyle = True Then
  DrawPBBeOS3D
Else
  DrawPBWin
End If
End Sub

Private Sub DrawPBBeOS()
On Error Resume Next
Dim L As Long, LL As Long, LD As Long
Dim V As Single, RV As Long
Dim W As Long, H As Long, X As Long, Y As Long

W = PB.ScaleWidth - 1
H = PB.ScaleHeight - 1
If Border = True Then W = W - 2: H = H - 2: X = 1: Y = 1

If Value > Max Then Value = Max
If Value < Min Then Value = Min
V = (Max - Min) / W
RV = (Value - Min) / V

L = RGB(18, 155, 240)
LL = RGB(38, 180, 255)
LD = RGB(0, 100, 150)

If Border = True Then
  PB.Line (0, 0)-(PB.ScaleWidth - 1, 0), &H80000010
  PB.Line (0, 0)-(0, PB.ScaleHeight - 1), &H80000010
  PB.Line (0, PB.ScaleHeight - 1)-(PB.ScaleWidth - 1, PB.ScaleHeight - 1), &H80000014
  PB.Line (PB.ScaleWidth - 1, 0)-(PB.ScaleWidth - 1, PB.ScaleHeight), &H80000014
End If

If Not RV = 0 Then
  PB.Line (X + 1, Y + 1)-(X + RV - 1, Y + H - 1), L, BF
  PB.Line (X, Y)-(X + RV, Y), LL
  PB.Line (X, Y)-(X, Y + H), LL
  PB.Line (X, Y + H)-(X + RV, Y + H), LD
  PB.Line (X + RV, Y)-(X + RV, Y + H + 1), LD
  PB.Line (X + RV + 1, Y)-(X + W, Y + H), PB.BackColor, BF
Else
  PB.Line (X, Y)-(X + W, Y + H), PB.BackColor, BF
End If
End Sub

Private Sub DrawPBReGet()
On Error Resume Next
Dim L As Long
Dim V As Single, RV As Long
Dim W As Long, H As Long, X As Long, Y As Long

W = PB.ScaleWidth - 1
H = PB.ScaleHeight - 1
If Border = True Then W = W - 2: H = H - 2: X = 1: Y = 1

If Value > Max Then Value = Max
If Value < Min Then Value = Min
V = (Max - Min) / W
RV = (Value - Min) / V

L = &H800000

If Border = True Then
  PB.Line (0, 0)-(PB.ScaleWidth - 1, PB.ScaleHeight - 1), CLR_WHITE, B
End If

If Not RV = 0 Then
  PB.Line (X, Y)-(X + RV, Y + H), L, BF
  PB.Line (X + RV + 1, Y)-(X + W, Y + H), &HFFC0C0, BF
Else
  PB.Line (X, Y)-(X + W, Y + H), &HFFC0C0, BF
End If
End Sub

Private Sub DrawPBWin()
On Error Resume Next
Dim V As Single, RV As Long
Dim W As Long, H As Long, X As Long, Y As Long

W = PB.ScaleWidth - 1
H = PB.ScaleHeight - 1
If Border = True Then W = W - 2: H = H - 2: X = 1: Y = 1


If Value > Max Then Value = Max
If Value < Min Then Value = Min
V = (Max - Min) / W
RV = (Value - Min) / V

If Border = True Then
  PB.Line (0, 0)-(PB.ScaleWidth - 1, 0), &H80000010
  PB.Line (0, 0)-(0, PB.ScaleHeight - 1), &H80000010
  PB.Line (0, PB.ScaleHeight - 1)-(PB.ScaleWidth - 1, PB.ScaleHeight - 1), &H80000014
  PB.Line (PB.ScaleWidth - 1, 0)-(PB.ScaleWidth - 1, PB.ScaleHeight), &H80000014
End If

If Not RV = 0 Then
  PB.Line (X, Y)-(X + RV, Y + H), PB.ForeColor, BF
  PB.Line (X + RV + 1, Y)-(X + W, Y + H), PB.BackColor, BF
Else
  PB.Line (X, Y)-(X + W, Y + H), PB.BackColor, BF
End If
End Sub

Private Sub DrawPBWinNew()
On Error Resume Next
Dim V As Single, RV As Long
Dim W As Long, H As Long, X As Long, Y As Long, BW As Long, BH As Long
Dim i As Long, iStep As Long, j As Long, TW As Long

W = PB.ScaleWidth - 1
H = PB.ScaleHeight - 1
If Border = True Then W = W - 2: H = H - 2: X = 1: Y = 1

If Value > Max Then Value = Max
If Value < Min Then Value = Min
V = (Max - Min) / W
RV = (Value - Min) / V

BH = H - 2
BW = H / 2
j = Y + 1

If Border = True Then
  PB.Line (0, 0)-(PB.ScaleWidth - 1, 0), &H80000010
  PB.Line (0, 0)-(0, PB.ScaleHeight - 1), &H80000010
  PB.Line (0, PB.ScaleHeight - 1)-(PB.ScaleWidth - 1, PB.ScaleHeight - 1), &H80000014
  PB.Line (PB.ScaleWidth - 1, 0)-(PB.ScaleWidth - 1, PB.ScaleHeight), &H80000014
End If

If Not RV = 0 Then
  iStep = BW + 1
  For i = X + 1 To RV Step iStep
    If Not i + BW - 1 > W Then TW = BW - 1 Else TW = W - (i + 1)
    If (i + TW > RV) Or (TW < 0) Then i = i + iStep: Exit For
    PB.Line (i, j)-(i + TW, j + BH), PB.ForeColor, BF
  Next
  If Not i > W Then PB.Line (i - iStep, j - 1)-(X + W, j + BH + 1), PB.BackColor, BF
Else
  PB.Line (X, j)-(X + W, j + BH), PB.BackColor, BF
End If
End Sub

Private Sub DrawPBWin3D()
On Error Resume Next
Dim V As Single, RV As Long
Dim W As Long, H As Long, X As Long, Y As Long, BW As Long, BH As Long
Dim i As Long, iStep As Long, j As Long, TW As Long

W = PB.ScaleWidth - 1
H = PB.ScaleHeight - 1
If Border = True Then W = W - 2: H = H - 2: X = 1: Y = 1

If Value > Max Then Value = Max
If Value < Min Then Value = Min
V = (Max - Min) / W
RV = (Value - Min) / V

BH = H - 2
BW = H / 2
j = Y + 1

If Border = True Then
  PB.Line (0, 0)-(PB.ScaleWidth - 1, 0), &H80000010
  PB.Line (0, 0)-(0, PB.ScaleHeight - 1), &H80000010
  PB.Line (0, PB.ScaleHeight - 1)-(PB.ScaleWidth - 1, PB.ScaleHeight - 1), &H80000014
  PB.Line (PB.ScaleWidth - 1, 0)-(PB.ScaleWidth - 1, PB.ScaleHeight), &H80000014
End If

If Not RV = 0 Then
  iStep = BW + 1
  For i = X + 1 To RV Step iStep
    If Not i + BW - 1 > W Then TW = BW - 1 Else TW = W - (i + 1)
    If i + TW > RV Then i = i + iStep: Exit For
    PB.Line (i, j)-(i + TW, j), &H80000014
    PB.Line (i, j)-(i, j + BH), &H80000014
    PB.Line (i, j + BH)-(i + TW, j + BH), &H80000010
    PB.Line (i + TW, j)-(i + TW, j + BH), &H80000010
    PB.Line (i + 1, j + 1)-(i + TW - 1, j + BH - 1), PB.ForeColor, BF
  Next
  If Not i > W Then PB.Line (i - iStep, j - 1)-(X + W, j + BH + 1), PB.BackColor, BF
Else
  PB.Line (X, j)-(X + W, j + BH), PB.BackColor, BF
End If
End Sub

Private Sub DrawPBBeOS3D()
On Error Resume Next
Dim L As Long, LL As Long, LD As Long
Dim V As Single, RV As Long
Dim W As Long, H As Long, X As Long, Y As Long, BW As Long, BH As Long
Dim i As Long, iStep As Long, j As Long, TW As Long

W = PB.ScaleWidth - 1
H = PB.ScaleHeight - 1
If Border = True Then W = W - 2: H = H - 2: X = 1: Y = 1

If Value > Max Then Value = Max
If Value < Min Then Value = Min
V = (Max - Min) / W
RV = (Value - Min) / V

BH = H - 2
BW = H / 2
j = Y + 1

L = RGB(18, 155, 240)
LL = RGB(38, 180, 255)
LD = RGB(0, 100, 150)

If Border = True Then
  PB.Line (0, 0)-(PB.ScaleWidth - 1, 0), &H80000010
  PB.Line (0, 0)-(0, PB.ScaleHeight - 1), &H80000010
  PB.Line (0, PB.ScaleHeight - 1)-(PB.ScaleWidth - 1, PB.ScaleHeight - 1), &H80000014
  PB.Line (PB.ScaleWidth - 1, 0)-(PB.ScaleWidth - 1, PB.ScaleHeight), &H80000014
End If

If Not RV = 0 Then
  iStep = BW + 1
  For i = X + 1 To RV Step iStep
    If Not i + BW - 1 > W Then TW = BW - 1 Else TW = W - (i + 1)
    If (i + TW > RV) Or (TW < 0) Then i = i + iStep: Exit For
    PB.Line (i, j)-(i + TW, j), LD
    PB.Line (i, j)-(i, j + BH), LD
    PB.Line (i, j + BH)-(i + TW, j + BH), LL
    PB.Line (i + TW, j)-(i + TW, j + BH), LL
    PB.Line (i + 1, j + 1)-(i + TW - 1, j + BH - 1), L, BF
  Next
  If Not i > W Then PB.Line (i - iStep, j - 1)-(X + W, j + BH + 1), PB.BackColor, BF
Else
  PB.Line (X, j)-(X + W, j + BH), PB.BackColor, BF
End If
End Sub

Private Sub PB_Paint()
RePaint
End Sub
